<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoCustomEffortGoal.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoCustomEffortGoal_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoCustomEffortGoal.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example shows creating a custom goal in a plugin library, which allows you to use the custom goal in C++, the command-line, Matlab, Python, and the GUI.See <a class="el" href="mocouserguide.html#mococustomgoal">Defining a custom goal or cost</a>.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleMocoCustomEffortGoal.cpp                              *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2019 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Christopher Dembia                                              *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &quot;MocoCustomEffortGoal.h&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Actuators/ActivationCoordinateActuator.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">std::unique_ptr&lt;Model&gt; createSlidingMassModel() {</div>
<div class="line">    <span class="keyword">auto</span> model = make_unique&lt;Model&gt;();</div>
<div class="line">    model-&gt;setName(<span class="stringliteral">&quot;sliding_mass&quot;</span>);</div>
<div class="line">    model-&gt;set_gravity(SimTK::Vec3(0, 0, 0));</div>
<div class="line">    <span class="keyword">auto</span>* body = <span class="keyword">new</span> Body(<span class="stringliteral">&quot;body&quot;</span>, 2.0, SimTK::Vec3(0), SimTK::Inertia(0));</div>
<div class="line">    model-&gt;addComponent(body);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Allows translation along x.</span></div>
<div class="line">    <span class="keyword">auto</span>* joint = <span class="keyword">new</span> SliderJoint(<span class="stringliteral">&quot;slider&quot;</span>, model-&gt;getGround(), *body);</div>
<div class="line">    <span class="keyword">auto</span>&amp; coord = joint-&gt;updCoordinate(<a name="a0"></a><a class="code" href="classOpenSim_1_1SliderJoint.html#a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06">SliderJoint::Coord::TranslationX</a>);</div>
<div class="line">    coord.setName(<span class="stringliteral">&quot;position&quot;</span>);</div>
<div class="line">    model-&gt;addComponent(joint);</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span>* actu = <span class="keyword">new</span> CoordinateActuator();</div>
<div class="line">    actu-&gt;setCoordinate(&amp;coord);</div>
<div class="line">    actu-&gt;setName(<span class="stringliteral">&quot;actuator&quot;</span>);</div>
<div class="line">    actu-&gt;setOptimalForce(1);</div>
<div class="line">    model-&gt;addComponent(actu);</div>
<div class="line"> </div>
<div class="line">    body-&gt;attachGeometry(<span class="keyword">new</span> Sphere(0.05));</div>
<div class="line"> </div>
<div class="line">    model-&gt;finalizeConnections();</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> model;</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line"> </div>
<div class="line">    MocoStudy study;</div>
<div class="line">    study.setName(<span class="stringliteral">&quot;sliding_mass&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Define the optimal control problem.</span></div>
<div class="line">    <span class="comment">// ===================================</span></div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Model (dynamics).</span></div>
<div class="line">    <span class="comment">// -----------------</span></div>
<div class="line">    problem.setModel(createSlidingMassModel());</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Bounds.</span></div>
<div class="line">    <span class="comment">// -------</span></div>
<div class="line">    <span class="comment">// Initial time must be 0, final time can be within [0, 5].</span></div>
<div class="line">    problem.setTimeBounds(MocoInitialBounds(0), MocoFinalBounds(0, 5));</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Initial position must be 0, final position must be 1.</span></div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/slider/position/value&quot;</span>, MocoBounds(-5, 5),</div>
<div class="line">            MocoInitialBounds(0), MocoFinalBounds(1));</div>
<div class="line">    <span class="comment">// Initial and final speed must be 0. Use compact syntax.</span></div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/slider/position/speed&quot;</span>, {-50, 50}, 0, 0);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Applied force must be between -50 and 50.</span></div>
<div class="line">    problem.setControlInfo(<span class="stringliteral">&quot;/actuator&quot;</span>, MocoBounds(-50, 50));</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Cost.</span></div>
<div class="line">    <span class="comment">// -----</span></div>
<div class="line">    problem.addGoal&lt;MocoFinalTimeGoal&gt;(<span class="stringliteral">&quot;time&quot;</span>);</div>
<div class="line">    <span class="comment">// Use the goal from the plugin:</span></div>
<div class="line">    problem.addGoal&lt;MocoCustomEffortGoal&gt;(<span class="stringliteral">&quot;effort&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Configure the solver.</span></div>
<div class="line">    <span class="comment">// =====================</span></div>
<div class="line">    MocoCasADiSolver&amp; solver = study.initCasADiSolver();</div>
<div class="line">    solver.set_num_mesh_intervals(50);</div>
<div class="line">    solver.set_verbosity(2);</div>
<div class="line">    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>);</div>
<div class="line">    solver.set_optim_ipopt_print_level(4);</div>
<div class="line">    solver.set_optim_max_iterations(50);</div>
<div class="line">    solver.set_optim_finite_difference_scheme(<span class="stringliteral">&quot;forward&quot;</span>);</div>
<div class="line">    solver.set_optim_sparsity_detection(<span class="stringliteral">&quot;random&quot;</span>);</div>
<div class="line">    solver.set_optim_write_sparsity(<span class="stringliteral">&quot;sliding_mass&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Specify an initial guess.</span></div>
<div class="line">    <span class="comment">// -------------------------</span></div>
<div class="line">    MocoTrajectory guess = solver.createGuess(<span class="stringliteral">&quot;bounds&quot;</span>);</div>
<div class="line">    guess.resampleWithNumTimes(2);</div>
<div class="line">    guess.setTime({0, 0.5});</div>
<div class="line">    guess.setState(<span class="stringliteral">&quot;/slider/position/value&quot;</span>, {0.0, 1.0});</div>
<div class="line">    solver.setGuess(guess);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the problem.</span></div>
<div class="line">    <span class="comment">// ==================</span></div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    std::cout &lt;&lt; <span class="stringliteral">&quot;Solution status: &quot;</span> &lt;&lt; solution.getStatus() &lt;&lt; std::endl;</div>
<div class="line">    study.visualize(solution);</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1SliderJoint_html_a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06"><div class="ttname"><a href="classOpenSim_1_1SliderJoint.html#a1c93d708a12564b46fcde77bb4be66eaadf25457a4acbb8220b36cbd34903fc06">OpenSim::SliderJoint::Coord::TranslationX</a></div><div class="ttdeci">@ TranslationX</div><div class="ttdoc">0</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
